#!/usr/bin/perl -w

my %c1;
my %c2;
my %c3;
open(A, $ARGV[0]);

while (my $line = <A>)
{
	my @parts = split(/\s+/,$line);
	shift @parts;
	
	for my $codon (@parts)
	{
		my $c;
		$c = substr($codon,0,1);
		if ($c ne '?')
		{
			$c1{$c} ++;
		}
		$c = substr($codon,1,1);
		if ($c ne '?')
		{
			$c2{$c} ++;
		}
		$c = substr($codon,2,1);
		if ($c ne '?')
		{
			$c3{$c} ++;
		}
	}
}

close(A);

my $t1;
my $t2;
my $t3;

while (my ($k,$v)=each %c1){$t1 += $v}
while (my ($k,$v)=each %c2){$t2 += $v}
while (my ($k,$v)=each %c3){$t3 += $v}


my %f1;
my %f2;
my %f3;
while (my ($k,$v)=each %c1){$f1{$k} = ($v / $t1)}
while (my ($k,$v)=each %c2){$f2{$k} = ($v / $t2)}
while (my ($k,$v)=each %c3){$f3{$k} = ($v / $t3)}


open(FREQ, ">" . $ARGV[1]);
my @dna = qw(A C T G);
for my $d1 (@dna)
{
	for my $d2 (@dna)
	{
		for my $d3 (@dna)
		{
			$codon = $d1 . $d2 . $d3;
			my $freq;
			if (($codon eq 'TAA') || ($codon eq 'TAG') || ($codon eq 'TGA'))
			{
				$freq = "0.0";
			}
			else
			{
				$freq = $f1{$d1} * $f2{$d2} * $f3{$d3};
			}
			print FREQ $codon . "\t" . $freq . "\n";
		}
	}
}
close(FREQ);
