#!/usr/bin/perl -w

# Converts an alignment from DNA to RY
# Usage: convert.pl DNAFILE RYFILE

open(DNA,$ARGV[0]);
open(RY,">" . $ARGV[1]);

my $line = <DNA>;
print RY $line;

while ($line = <DNA>)
{
	if ($line =~ /(.*?\s+)(.*)/)
	{
		$name = $1;
		$seq = $2;
		$seq =~ s/[CT]/Y/g;
		$seq =~ s/[AG]/R/g;
		
		print RY $name . $seq;
	}
	else
	{
		print RY $line;
	}
}
close(DNA);
close(RY);